Loading...
Searching...
No Matches
IDableDigraphComponent< BAS > Class Template Reference

## Detailed Description

template<typename BAS = BaseDigraphComponent>
class lemon::concepts::IDableDigraphComponent< BAS >

This class describes the interface of idable directed graphs. It extends BaseDigraphComponent with the core ID functions. The ids of the items must be unique and immutable. This concept is part of the Digraph concept.

`#include <lemon/concepts/graph_components.h>`

Inheritance diagram for IDableDigraphComponent< BAS >:
[legend]

## Public Member Functions

int | id (const Node &) const
| Return a unique integer id for the given node.
Node | nodeFromId (int) const
| Return the node by its unique id.
int | id (const Arc &) const
| Return a unique integer id for the given arc.
Arc | arcFromId (int) const
| Return the arc by its unique id.
int | maxNodeId () const
| Return an integer greater or equal to the maximum node id.
int | maxArcId () const
| Return an integer greater or equal to the maximum arc id.
Public Member Functions inherited from BaseDigraphComponent
Node | source (const Arc &) const
| Return the source node of an arc.
Node | target (const Arc &) const
| Return the target node of an arc.
Node | oppositeNode (const Node &, const Arc &) const
| Return the opposite node on the given arc.

## Additional Inherited Members

Public Types inherited from BaseDigraphComponent
typedef GraphItem< 'n'> | Node
| Node class of the digraph.
typedef GraphItem< 'a'> | Arc
| Arc class of the digraph.

## Member Function Documentation

## id() [1/2]

template<typename BAS = BaseDigraphComponent>

int id | ( | const Node & |  | ) | const

inline

This function returns a unique integer id for the given node.

## nodeFromId()

template<typename BAS = BaseDigraphComponent>

Node nodeFromId | ( | int |  | ) | const

inline

This function returns the node by its unique id. If the digraph does not contain a node with the given id, then the result of the function is undefined.

## id() [2/2]

template<typename BAS = BaseDigraphComponent>

int id | ( | const Arc & |  | ) | const

inline

This function returns a unique integer id for the given arc.

## arcFromId()

template<typename BAS = BaseDigraphComponent>

Arc arcFromId | ( | int |  | ) | const

inline

This function returns the arc by its unique id. If the digraph does not contain an arc with the given id, then the result of the function is undefined.

## maxNodeId()

template<typename BAS = BaseDigraphComponent>

int maxNodeId | ( |  | ) | const

inline

This function returns an integer greater or equal to the maximum node id.

## maxArcId()

template<typename BAS = BaseDigraphComponent>

int maxArcId | ( |  | ) | const

inline

This function returns an integer greater or equal to the maximum arc id.